Imports System.Data.OleDb
Public Class Form1

    Private Function CreateConnString(ByVal Str As String) _
     As String

        Return "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" _
        + Str + ";Extended Properties=""Excel 8.0;HDR=YES;"""


    End Function
    Private Sub Btn_NewSheet_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles Btn_NewSheet.Click

        Dim Conn As New OleDbConnection
        Dim Comm As New OleDbCommand

        Conn.ConnectionString = CreateConnString("D:\k\Book1.xls")
        Comm.Connection = Conn
        Comm.CommandText = _
         "Create Table MySheet (F1 char(255), F2 char(255))"

        Try
            Conn.Open()
            Comm.ExecuteNonQuery()
            MsgBox("Created.")
            Conn.Close()
        Catch ex As Exception
            MsgBox("Error.")
            Conn.Close()
        End Try

    End Sub

    Private Sub Btn_Insert_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles Btn_Insert.Click

        Dim Conn As New OleDbConnection
        Dim Comm As New OleDbCommand

        Conn.ConnectionString = CreateConnString("D:\k\Book1.xls")
        Comm.Connection = Conn
        Comm.CommandText = _
         "Insert INTO [MySheet$] (F1, F2) Values ('1','A')"

        Try
            Conn.Open()
            Comm.ExecuteNonQuery()
            MsgBox("Inserted.")
            Conn.Close()
        Catch ex As Exception
            MsgBox("Error.")
            Conn.Close()
        End Try

    End Sub

    Private Sub Btn_Retrieve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Retrieve.Click

        Dim Conn As New OleDbConnection
        Dim Comm As New OleDbCommand
        Dim DReader As OleDbDataReader
        Dim Str As String = ""

        Conn.ConnectionString = CreateConnString("D:\k\MyBook.xls")
        Comm.Connection = Conn
        Comm.CommandText = "Select * From [Products$]"

        Try
            Conn.Open()
            DReader = Comm.ExecuteReader

            Do While DReader.Read
                Str = Str + vbCrLf + DReader.GetString(0) _
                + " , " + DReader.GetString(1)
            Loop

            MsgBox(Str)
            DReader.Close()
            Conn.Close()
        Catch ex As Exception
            MsgBox("Error.")            
            Conn.Close()
        End Try

    End Sub

    Private Sub Btn_Update_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Update.Click

        Dim Conn As New OleDbConnection
        Dim Comm As New OleDbCommand

        Conn.ConnectionString = CreateConnString("D:\k\MyBook.xls")
        Comm.Connection = Conn
        Comm.CommandText = _
         "Update [Products$] SET Name = 'ABC' Where Prod = 'Prod1'"

        Try
            Conn.Open()
            Comm.ExecuteNonQuery()
            MsgBox("Updated.")
            Conn.Close()
        Catch ex As Exception
            MsgBox("Error.")
            Conn.Close()
        End Try

    End Sub
End Class
